//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "q_QuidoDllMap.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
   QuidoHandle = 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::cmdCreateClick(TObject *Sender)
{
  //Vytvoit Quido

  if (!QDllOK()) throw Exception(QDllInitMsg()); //Zjitn zda byla sprvn namapovna knihovna (pi prvnm voln funcke QDllOK se knihovna namapuje)

  if (QuidoHandle){ //Pokud je vytvoen jin Quido ...
    qReleaseQuido(QuidoHandle); //... zru se ...
    QuidoHandle = 0; //... vynuluje se handle ...
    OnQuidoClose(); //... shov se z formule ovldn quida
  }
  QuidoHandle = qCreateQuido(ConnectionString->Text.c_str(),txtParams->Text.c_str());
  //-- Vytvo se Quido podle pipojovacho etzce, kter definuje komunikan rozhran. dle se ped adresa Quida v parametrech quida

  if (QuidoHandle){
     //-- pokud bylo quido vytvoeno, zaregistruje se zasln udlost pomoc Windows zprv
     qRegisterMsgNotifications(QuidoHandle,(unsigned int)this->Handle,WM_QuidoEvent,0);
  } else ShowMessage("Quido nebylo vytvoeno"); //pokud Quido nelze podle pipojovacho etzce vytvoit
}

void __fastcall TForm1::WMQuidoEvent(TMessage & Msg){ //Zasln udlosti Quidem
  switch(Msg.LParamLo){
    case qev_CIOpen: //Pi oteven komunikanho rozhran
          OnQuidoOpen();
          break;
    case qev_CIClose: //Pi zaven komunikanho rozhran
          OnQuidoClose();
          break;
    case qev_InputChange: //Pi zjitn zmn vstupu
          OnInputChange(Msg.LParamHi & 0xFF);
          break;
  }
}

//---------------------------------------------------------------------------

void __fastcall TForm1::cmdDlgClick(TObject *Sender)
{
  //Nastaven pipojovacho etzce vestavnm dialogem

  if (!QDllOK()) throw Exception(QDllInitMsg()); //Zjitn zda byla sprvn natena knihovna
  char ConnStr[513]="";
  int Len = 512;
  int Ret=0;
  //Vyvoln dialogu pro vytvoen pipojovacho etzce
  if ((ciGetConnectionStringDlg(ConnStr,Len,Ret,ConnectionString->Text.c_str(),NULL)==0) && Ret){
     //Pokud bylo stisknuto OK, ope se etzec do textovho pole
     ConnStr[Len]=0;
     ConnectionString->Text = ConnStr;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::cmdOpenClick(TObject *Sender)
{
  if (!QuidoHandle){
    ShowMessage("Quido nen vytvoeno");
    return;
  }
  qOpen(QuidoHandle); //Oteve se komunikan rozhran
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnQuidoOpen(){ //Pi udlosti oteven rozhran
  char Buf[128];
  int Ln;
  int Cnt;
  Ln=128;
  if (qInfo(QuidoHandle,Buf,Ln)==0){ //Naten identifikanho etzce
    Buf[Ln]=0;
    Label2->Caption = Buf;
  }else throw Exception("Nebylo nateno info z Quida.");

  if (qGetAutoNotify(QuidoHandle,Cnt)==0){ //Zjist stav automatickho vysln
     chAutoNotify->Checked = Cnt;
  }else chAutoNotify->State = cbGrayed;
  ComboBoxOut->Clear();
  //Zjitn potu vstup a vypsn do ComboBoxu
  if ((Cnt=qOutputsCount(QuidoHandle))<0) throw Exception("Nebyl zjitn poet vstup");
  for (int i=0;i<Cnt;i++){
    ComboBoxOut->Items->Add("Vstup "+IntToStr(i+1));
  }
  if (Cnt>0){
   //Nastaven prvnho vstupu
   ComboBoxOut->ItemIndex = 0;
   ComboBoxOutChange(ComboBoxOut);
  }

  ComboBoxIn->Clear();
  //Zjitn potu vstup a vypsn do ComboBoxu
  if ((Cnt=qInputsCount(QuidoHandle))<0) throw Exception("Nebyl zjitn poet vstup");
  for (int i=0;i<Cnt;i++){
    ComboBoxIn->Items->Add("Vstup "+IntToStr(i+1));
  }
  if (Cnt>0){
   //Nastaven prvnho vstupu
   ComboBoxIn->ItemIndex = 0;
   ComboBoxInChange(ComboBoxIn);
  }

  //Zobrazen ovldn Quida
  gbQuido->Visible = true;
}

void __fastcall TForm1::OnQuidoClose(){ //Pi udlosti zaven rozhran
  //Schovn ovldn Quida
  gbQuido->Visible = false;
}

void __fastcall TForm1::OnInputChange(int Index){ //Pi udlosti zmny vstupu
  if (Index==ComboBoxIn->ItemIndex){ //Pokud je zmnn vstup vybran (zobrazen)
      int OS,R,F;
      //Zjist se naposledy znm stav vstupu (po tto udlosti by ml bt aktuln, nen teba znovu komunikovat s Quidem)
      if (qGetRecentInputByIndex(QuidoHandle,ComboBoxIn->ItemIndex,OS)==0){
         InIndik->Brush->Color = OS?clRed:clGray;
         //Zjitn stavu tae
         if (qInputCounterValueByIndex(QuidoHandle,Index,OS,0)==0)
            lblCounterValue->Caption = IntToStr(OS);
            else lblCounterValue->Caption = "";
         //Zjitn nastaven tae
         if (qGetCounterSetting(QuidoHandle,Index,R,F)==0){
            if (R && F) lblCounter->Caption = "ta: Ob hrany";
            else if (R) lblCounter->Caption = "ta: Nbn hrana";
            else if (F) lblCounter->Caption = "ta: Sestupn hrana";
            else lblCounter->Caption = "ta vypnut";
         }else lblCounter->Caption = "ta nen";
      }
  }
}
//-----------------


void __fastcall TForm1::cmdCloseClick(TObject *Sender)
{
  if (!QuidoHandle){
    ShowMessage("Quido nen vytvoeno");
    return;
  }
  qClose(QuidoHandle); //Zaven komunikanho rozhran s Quidem

}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
  //Pi ukonen zruit Quido
  if (QuidoHandle) qReleaseQuido(QuidoHandle);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBoxOutChange(TObject *Sender)
{
  //Pi zmn vbru vstupu
  if (QuidoHandle)
    if (ComboBoxOut->ItemIndex>=0){
      chOut->Caption = "Vstup " + IntToStr(ComboBoxOut->ItemIndex+1);
      int OS;
      //Zjistit stav vybranho vstupu
      if (qOutputStateByIndex(QuidoHandle,ComboBoxOut->ItemIndex,OS)!=0) throw Exception("Nelze zjistit stav vstupu.");
      //Zobrazit
      chOut->Checked = OS;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::chOutClick(TObject *Sender)
{
  //Zmnit stav vybranho vstupu

  if (QuidoHandle) // (je vytvoeno Quido?)
    if (ComboBoxOut->ItemIndex>=0){ //(je vybrn vstup?)
      int OS=(int)chOut->Checked; //Zjistit stav zakrtvtka
      if (qSetOutput(QuidoHandle,ComboBoxOut->ItemIndex,OS)!=0) throw Exception("Vstup nebyl nastaven.");
      //Nastavit vstup Quida
    }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ComboBoxInChange(TObject *Sender)
{
  //Pi zmn vbru vstupu
  if (QuidoHandle)
    if (ComboBoxIn->ItemIndex>=0){ //Vybran vstup
      int OS,R,F;
      //Zjistit stav vybranho vstupu
      if (qInputStateByIndex(QuidoHandle,ComboBoxIn->ItemIndex,OS)!=0) throw Exception("Nelze zjistit stav vstupu.");
      //Zmnit barvu indiktoru (erven=vstup aktivn, ed= vstup neaktivn)
      InIndik->Brush->Color = OS?clRed:clGray;
      //Zjitn stavu tae
      if (qInputCounterValueByIndex(QuidoHandle,ComboBoxIn->ItemIndex,OS,0)==0)
         lblCounterValue->Caption = IntToStr(OS);
         else lblCounterValue->Caption = "";
      //Zjitn nastaven tae
      if (qGetCounterSetting(QuidoHandle,ComboBoxIn->ItemIndex,R,F)==0){
         if (R && F) lblCounter->Caption = "ta: Ob hrany";
         else if (R) lblCounter->Caption = "ta: Nbn hrana";
         else if (F) lblCounter->Caption = "ta: Sestupn hrana";
         else lblCounter->Caption = "ta vypnut";
      }else lblCounter->Caption = "ta nen";
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::chAutoNotifyClick(TObject *Sender)
{
  if (chAutoNotify->State != cbGrayed){
    int Ch = chAutoNotify->Checked?1:0;
    //Nastaven automatickho vysln
    if (qSetAutoNotify(QuidoHandle,Ch)!=0) ShowMessage("Automatick vysln nebylo nastaveno.");
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::cmdResetClick(TObject *Sender)
{
  //Restartovn Quida
  if (qReset(QuidoHandle)!=0) ShowMessage("Nezdailo se resetovat");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::cmdSPInfoClick(TObject *Sender)
{
  //Ukzka pout funkce qSndRcvSpin97
  //Tuto funkci je vhodn pouvat v ppadech, kdy je teba provst pkaz, kter nem implementovanou speciln funkci
  //pklad pole spinel instrukci 0xF3 pro zjskn identifikanho etzce Quida (to je implementovno funkc qInfo)
  char Info[128];
  int Len=128;
  unsigned char Ack;
  int Ret = qSndRcvSpin97(QuidoHandle,0xF3,NULL,0,Ack,Info,Len,1000);
  //funkci se ped handle Quida, instrukce (0xF3), data a jejich dka (v tto instrukci se data nepedvaj, jsou tedy NULL a dlka 0), Ack pro zskn nvratovho kdu (0=OK),
  //buffer Info pro pjem vrcench dat o velikosti Len (pokud se neoekvaj vrcen data, me bt NULL a velikost 0). Len se zmn na aktuln velikost vrcench dat.

  if (Ret==0){ //pokud byla instrukce provedena (a potvrzena)
     if (Ack==0){ //pokud je nvratov kd Ack = 0 (OK)
        Info[Len]=0; //Pid se za pijat data 0 (pijat data jsou v tto instrukci etzec, je teba ho ukonit)
        ShowMessage(Info); //Zobraz se pijat etzec
     }else ShowMessage("Instrukce nebyla spn vykonna");
  }else ShowMessage("Bez odezvy");
}
//---------------------------------------------------------------------------

