(*
  Pklad pouit knihovny QuidoStackDll.dll pro ovldn Quida.
  Vytvoeno pro Delphi 7

  Vydavatel :  Papouch s.r.o. - http://www.papouch.com/
  Autor     :  Martin Zmenk zamecnik@papouch.com

  popis     : ukzkov aplikace pro pouit knihovny QuidoStackDll.dll pro ovldn zazen Quido firmy Papouch s.r.o.
              pes objektov rozhran definovan v unit uo_Quido.pas. Demonstruje zejmna zkladn rutiny ovldn vstup a vstup

  Poznmky  : k pouit funkc jsou poteba knihovny QuidoStackDll.dll, CommIntfDll.dll, unita mapujc funkce q_QuidoDllMapD.pas a unita pro zaobalen do objektu uo_Quido.pas.
              v ppad pouit pro USB jsou poteba t nainstalovan ovladae FTD direct drivers a knihova FTD2XX.dll, nebo nainstalovan virtuln sriov port

*)
unit uf_QuidoSample;

interface

uses
  Windows, SysUtils, Controls, Forms, dialogs,
  StdCtrls,uo_Quido, ImgList, ComCtrls, ExtCtrls, Menus, Classes;
type
  TfQuidoDemo = class(TForm)
    GroupBox1: TGroupBox;
    ConnectionString: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    QuidoParams: TEdit;
    cmdCreateQ: TButton;
    cmdOpen: TButton;
    cmdClose: TButton;
    ImageList1: TImageList;
    Panel1: TPanel;
    gbOvladani: TGroupBox;
    Label3: TLabel;
    lwInputs: TListView;
    lblQuidoID: TLabel;
    pmInputs: TPopupMenu;
    Vynulovatta1: TMenuItem;
    lwOutputs: TListView;
    chAuto: TCheckBox;
    chPeriod: TCheckBox;
    cmdReset: TButton;
    chRefresh: TButton;
    Timer1: TTimer;
    pmOutputs: TPopupMenu;
    Zmnitstavnaas1: TMenuItem;
    Panel2: TPanel;
    Label4: TLabel;
    cmdDlg: TButton;
    Nastaven1: TMenuItem;
    Nbnhrana1: TMenuItem;
    Sestupnhrana1: TMenuItem;
    Ob1: TMenuItem;
    Vypnuto1: TMenuItem;
    procedure cmdCreateQClick(Sender: TObject);
    procedure cmdOpenClick(Sender: TObject);
    procedure cmdCloseClick(Sender: TObject);
    procedure Vynulovatta1Click(Sender: TObject);
    procedure cmdResetClick(Sender: TObject);
    procedure lwOutputsChange(Sender: TObject; Item: TListItem; Change: TItemChange);
    procedure chRefreshClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure chPeriodClick(Sender: TObject);
    procedure chAutoClick(Sender: TObject);
    procedure Zmnitstavnaas1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cmdDlgClick(Sender: TObject);
    procedure Vypnuto1Click(Sender: TObject);
    procedure Nbnhrana1Click(Sender: TObject);
    procedure Sestupnhrana1Click(Sender: TObject);
    procedure Ob1Click(Sender: TObject);
  private
    Quido:TQuido; //-- objekt quida
    //--- Udlosti quida
    procedure QuidoOpened(sender:TObject);
    procedure QuidoClosed(sender:TObject);
    procedure QuidoInputChange(sender:TObject;Index:integer;Old:boolean;New:boolean);
    procedure QuidoOutputsChange(sender:TObject);
  public
    procedure DisplayQuido;
    procedure RefreshQuido(quick:boolean=true);
  end;

var
  fQuidoDemo: TfQuidoDemo;

implementation

{$R *.dfm}

procedure TfQuidoDemo.cmdCreateQClick(Sender: TObject);
begin
  if assigned(Quido) then //-- zruen ppadnho pedchozho quida
  begin
    FreeAndNil(Quido);
    lblQuidoID.Caption := '';
    gbOvladani.Visible := false;
  end;
  try
    Quido := TQuido.Create(ConnectionString.Text,QuidoParams.Text); //-- vytvo nov objekt quida s danmy parametry
  except
    on E:exception do MessageDlg(e.Message,mtError,[mbOK],0);
  end;
  if assigned(Quido) then //-- pokud se podailo vytvoit
  begin
    //-- namapovn udlost oteven a zaven komunikace s quidem
    Quido.OnOpen := QuidoOpened;
    Quido.OnClose := QuidoClosed;
    if MessageDlg('Byl vytvoen objekt quida. Chcete ho otevt?',mtInformation,[mbYes,mbNo],0)=IDYES
     then Quido.Open; //-- oteven komunikace s quidem
  end;

  Timer1.Enabled := false;
end;

procedure TfQuidoDemo.cmdOpenClick(Sender: TObject);
begin
  if assigned(Quido) then Quido.Open else ShowMessage('Objekt Quida nebylo vytvoen!');
                          //-oteve se komunikace s quidem
end;

procedure TfQuidoDemo.cmdCloseClick(Sender: TObject);
begin
  if assigned(Quido) then Quido.Close else ShowMessage('Objekt Quida nebylo vytvoen!');
                         //-zave se komunikace s quidem
end;

procedure TfQuidoDemo.QuidoClosed(sender: TObject);
begin
  //-- pi zaven komunikace s quidem
  gbOvladani.Visible := false;
  Timer1.Enabled := false;
  //--odmapovn udlost quida
  Quido.OnInputChange := nil;
  Quido.OnOutputsChange := nil;
end;


procedure TfQuidoDemo.QuidoOpened(sender: TObject);
begin
  //-- pi oteven komunikace s quidem
  DisplayQuido;
  Timer1.Enabled := chPeriod.Checked;
end;

procedure TfQuidoDemo.QuidoOutputsChange(sender: TObject);
var i:integer;
    LWI:TListItem;
begin
  //-- pi zjitn zmn stavu nkterch vstup
  if assigned(Quido) then
  for i:=0 to Quido.OutputsCount - 1 do
  begin
     LWI:=lwOutputs.Items.Item[i];
     LWI.Checked := Quido.RecentOutputState[i];
     if LWI.Checked then LWI.SubItems.Strings[0] := 'Sepnuto' else LWI.SubItems.Strings[0] := 'Rozepnuto';
  end;
end;

procedure TfQuidoDemo.DisplayQuido;
var i,x:integer;
    LWI:TListItem;
    R,F:boolean;
    s:string;
begin
  //Naten informac o Quidu a zobrazen na formuli, vypsn jeho vstupu, vstup a ta
  //Pokud je Quido NIL, informace se schovaj

  if assigned(Quido) then
  begin
    //-- vypsn identifikace
    lblQuidoID.Caption := Quido.DeviceInfo;

    //-- naten vstup
    lwInputs.Clear;
    Quido.RefreshInputs(true);
    x:=Quido.InputsCount;
    for i:=0 to x-1 do
    begin
      LWI:=lwInputs.Items.Add;
      try
        LWI.Caption := inttostr(i+1);
        if Quido.RecentInputState[i] then LWI.ImageIndex := 1 else LWI.ImageIndex := 0;
        if Quido.InputCountersCount>i then
        begin
          LWI.SubItems.Add(inttostr(Quido.GetInputCounterValue(i,false)));
          Quido.GetCounterSetting(I,R,F);
          if F and R
            then S:='Ob'
            else if R then S:='Nbn'
            else if F then S:='Sestupn'
            else S:='Vypnuto';
          LWI.SubItems.Add(S)
        end;
      except
      end;
    end;
    //-- naten vstup
    lwOutputs.Items.Clear;
    Quido.RefreshOutputs(true);
    x:=Quido.OutputsCount;
    for i:=0 to x-1 do
    begin
      try
        LWI:=lwOutPuts.Items.Add;
        LWI.Caption := inttostr(i+1);
        if Quido.RecentOutputState[i] then
        begin
          LWI.Checked := true;
          LWI.SubItems.Add('Sepnuto');
        end else
        begin
          LWI.Checked := false;
          LWI.SubItems.Add('Rozepnuto');
        end;
      except
      end;
    end;
    //--automatick vysln
    chAuto.Checked := Quido.AutoInputNotification;
    //--namapovn udlost quida
    Quido.OnInputChange := QuidoInputChange; //-- vyvol se pro kad zmnn vstup zvl᚝
    Quido.OnOutputsChange := QuidoOutputsChange; //-- vyvol se hromadn pi zjitn zmn nkterho vstupu

    gbOvladani.Visible := true;
  end else
  begin
    //schovn
    lblQuidoID.Caption := '';
    gbOvladani.Visible := false;
  end;
end;

procedure TfQuidoDemo.Vynulovatta1Click(Sender: TObject);
begin
  //-- Vynuluje ta vybranho vstupu
  if lwInputs.ItemIndex >=  0 then Quido.GetInputCounterValue(lwInputs.ItemIndex,true);
end;

procedure TfQuidoDemo.QuidoInputChange(sender: TObject; Index: integer; Old,
  New: boolean);
var LWI:TListItem;
    R,F:boolean;
    S:string;
begin
  //-- pi zjitn zmn vstupu
try
  LWI:=lwInputs.Items.Item[Index];
  if assigned(LWI) then
  with LWI do
  begin
    if Quido.RecentInputState[Index]
      then ImageIndex := 1
      else ImageIndex := 0;
    SubItems.Strings[0]:=inttostr(Quido.GetInputCounterValue(index,false));
    Quido.GetCounterSetting(Index,R,F);
    if F and R
      then S:='Ob'
      else if R then S:='Nbn'
      else if F then S:='Sestupn'
      else S:='Vypnuto';
    SubItems.Strings[1]:=S;
  end;
except
end;
end;

procedure TfQuidoDemo.cmdResetClick(Sender: TObject);
begin
  //-- Resetuje quido. pokud se periodicky zobrazuj stavy, oddl se prvn zjiovn za 3 vteiny
  if Timer1.Enabled then Timer1.Interval := 3000;
  Quido.Reset;
end;

procedure TfQuidoDemo.lwOutputsChange(Sender: TObject; Item: TListItem;
  Change: TItemChange);
  var s:string;
begin
 //-- Zmna nkter poloky v seznamu vstup (v ListView)...
 //-- Zjistme zda uivatel nechtl zmnit stav vstupu zakrtvacm polkem
 //  , pokud ano, provede se zmna vstupu na quidu ...
 if assigned(Quido) then  // ... je vytvoeno quido ...
  if Change = ctState then //... mohlo by se jednat o zakrtnut polka ...
   if assigned(Quido.OnOutputsChange) then //... nejedn se o udlost vzniklou pi vytven poloky v ListView ...
    if Item.Checked <> Quido.RecentOutputState[Item.Index] //... zakrtvtko neodpovda stavu vstupu ...
      then Quido.OutputState[Item.Index]:=Item.Checked; //... Zmnme stav vstupu
end;

procedure TfQuidoDemo.chRefreshClick(Sender: TObject);
begin
  //-- zobraz aktuln stavy quida (vstupy, vstupy, tae)
  RefreshQuido(false);
end;

procedure TfQuidoDemo.Timer1Timer(Sender: TObject);
begin
  try
   if assigned(Quido) and Quido.Active then
   begin
     //- pokud je quido oteven, obnov se zobrazen jeho stav:
     RefreshQuido;
   end;
  except
  end;
  Timer1.Interval := 500;
end;

procedure TfQuidoDemo.chPeriodClick(Sender: TObject);
begin
  //- zapne (nebo vypne) se asova, kter periodicky zobrazuje aktuln stavy quida 
  Timer1.Enabled := chPeriod.Checked;
end;

procedure TfQuidoDemo.RefreshQuido(quick:boolean=true);
var B:boolean;
    i,x:integer;
    LWI:TListItem;
    R,F:boolean;
    s:string;
begin
  //- Obnov zobrazen stav vstup, vstup a ta

  if Quick then
  begin
      Quido.RefreshInputs;
      Quido.RefreshOutputs;
      b:=Quido.AutoInputNotification;
      if b<>chAuto.Checked then chAuto.Checked := Quido.AutoInputNotification;
  end else
  begin
      b:=Quido.AutoInputNotification;
      if b<>chAuto.Checked then chAuto.Checked := Quido.AutoInputNotification;
      Quido.RefreshInputs;
      x:=Quido.InputsCount;
      for i:=0 to x-1 do
      begin
          LWI:=lwInputs.Items.Item[i];
          if assigned(LWI) then
          with LWI do
          begin
            if Quido.RecentInputState[i] then ImageIndex := 1 else ImageIndex := 0;
            SubItems.Strings[0]:=inttostr(Quido.GetInputCounterValue(index,false));
            Quido.GetCounterSetting(Index,R,F);
            if F and R
              then S:='Ob'
              else if R then S:='Nbn'
              else if F then S:='Sestupn'
              else S:='Vypnuto';
            SubItems.Strings[1]:=S;

          end;
      end;
      Quido.RefreshOutputs;
      x:=Quido.OutputsCount;
      for i:=0 to x - 1 do
      begin
         LWI:=lwOutputs.Items.Item[i];
         if assigned(LWI) then
         begin
           LWI.Checked := Quido.RecentOutputState[i];
           if LWI.Checked then LWI.SubItems.Strings[0] := 'Sepnuto' else LWI.SubItems.Strings[0] := 'Rozepnuto';
         end;
      end;
  end;
end;

procedure TfQuidoDemo.chAutoClick(Sender: TObject);
begin
  //-- Nastav nebo zru se v Quidu automatick vysln zmny vstup
  Quido.AutoInputNotification := chAuto.Checked;
end;

procedure TfQuidoDemo.Zmnitstavnaas1Click(Sender: TObject);
var s:string;
    i:integer;
begin
  //-- zmn stav vstupu na zadanou dobu ve vteinch
  s:='5';
  if lwOutputs.ItemIndex >=  0 then
   if InputQuery('Zmnit stav vstupu na as','Zadejte as (sec)',S) then
     if TryStrToInt(s,i) then
     begin
      Quido.SetOutputStateTimed(lwOutputs.ItemIndex,not Quido.RecentOutputState[lwOutputs.ItemIndex],i);
      Quido.RefreshOutputs(true);
     end;
end;

procedure TfQuidoDemo.FormDestroy(Sender: TObject);
begin
  Timer1.Enabled := false;
  freeandnil(Quido);
end;

procedure TfQuidoDemo.cmdDlgClick(Sender: TObject);
var s:AnsiString;
begin
  //--- Vytvoen pipojovacho etzce pomoc dialogu
  s:=ConnectionString.Text;
  if TQuido.ConnectionStringDlg(S)
   then ConnectionString.Text := s;
end;

procedure TfQuidoDemo.Vypnuto1Click(Sender: TObject);
begin
  //-- Vypnut tae vybranho vstupu
  if lwInputs.ItemIndex >=  0 then
  begin
    Quido.SetCounterSetting(lwInputs.ItemIndex,false,false);
    RefreshQuido(false);
  end;
end;

procedure TfQuidoDemo.Nbnhrana1Click(Sender: TObject);
begin
  //-- Nastaven tae vybranho vstupu na nbnou hranu
  if lwInputs.ItemIndex >=  0 then
  begin
    Quido.SetCounterSetting(lwInputs.ItemIndex,true,false);
    RefreshQuido(false);
  end;
end;

procedure TfQuidoDemo.Sestupnhrana1Click(Sender: TObject);
begin
  //-- Nastaven tae vybranho vstupu na sestupnou hranu
  if lwInputs.ItemIndex >=  0 then
  begin
    Quido.SetCounterSetting(lwInputs.ItemIndex,false,true);
    RefreshQuido(false);
  end;
end;

procedure TfQuidoDemo.Ob1Click(Sender: TObject);
begin
  //-- Nastaven tae vybranho vstupu na ob hrany
  if lwInputs.ItemIndex >=  0 then
  begin
    Quido.SetCounterSetting(lwInputs.ItemIndex,true,true);
    RefreshQuido(false);
  end;
end;

end.
